----- Super constructor for entities and components	
	create = {}
	
-- Entity
	local idCount = 0
	function create.entity(name , ...)
		if assetManager.listEntities[name] then
			local pointer = assetManager.listEntities[name]
			local object = entity:new()
			
			setmetatable(object , pointer)
			pointer.__index = pointer

			object:new(...)
			
			idCount = idCount + 1
			object.id = idCount
			object.idChild = 0
			object.idCell = {1 , 1}
			object.idCellStatic = {1 , 1}
			
			object:makeKey()
			
			world.rootEntity:addChild(object)
			
			return object
		end
	end
	
-- GUI entity
	local idCountGUI = 0
	function create.entityGUI(name , ...)
		if assetManager.listEntities[name] then
			local pointer = assetManager.listEntities[name]
			local object = entityGUI:new()
			
			setmetatable(object , pointer)
			pointer.__index = pointer

			object:new(...)
			
			idCountGUI = idCountGUI + 1
			object.id = idCountGUI
			object.idChild = 0
			
			object:makeKey()
			
			world.rootEntity:addChild(object)
			
			return object
		end
	end
	
-- Component
	function create.component(name , targetEntity , ...)
		if assetManager.listComponents[name] then
			local pointer = assetManager.listComponents[name]
			local object = component:new()
			
			setmetatable(object , pointer)
			pointer.__index = pointer
			
			object.transform = targetEntity.transform
			object.parent = targetEntity
			
			object:new(...)
			
			targetEntity.components[name] = object
		end
	end
