---- Utility methods for debug graphics
	debugDraw = {}
	
-- Circle polygon
	local coords = {}
	local sidesPrev
	local radiusPrev
	local range
	function debugDraw.circle(x , y , radius , sides)
		--if sides ~= sidesPrev or radius ~= radiusPrev then
			coords = {}
			range = (math.pi * 2) / sides
			for i = 1 , sides do
				coords[i * 2 - 1] = x + radius * math.cos(range * i)
				coords[i * 2] = y + radius * math.sin(range * i)
			end
			--sidesPrev = sides
			--radiusPrev = radius
		--end
		love.graphics.polygon("line" , coords)
	end

---- Table methods
-- Merge
	function table.merge(tableOne, tableTwo)
		for i , j in pairs(tableTwo) do
			tableOne[i] = j
		end	
		return tableOne
	end

	
---- Other utilities
	utility = {}
	
-- Rectangle mesh
	function utility.newQuad(sizeX , sizeY , offsetX , offsetY)
		offsetX = offsetX or sizeX * 0.5
		offsetY = offsetY or sizeY * 0.5
		
		return love.graphics.newMesh(
					{{-offsetX , sizeY - offsetY , 0 , 0} ,
					{sizeX - offsetX , sizeY - offsetY , 1 , 0} ,
					{sizeX - offsetX , -offsetY , 1 , 1} ,
					{-offsetX , -offsetY , 0 , 1}})
	end
	
-- Rectangle with custom uv's
	function utility.newFrame(sizeX , sizeY , uTopLeft , vTopLeft , uBottomRight , vBottomRight , offsetX , offsetY)
		offsetX = sizeX * 0.5 + (-offsetX or 0)
		offsetY = sizeY * 0.5 + (-offsetY or 0)
		
		return love.graphics.newMesh(
					{{-offsetX , sizeY - offsetY , uTopLeft , vTopLeft} ,
					{sizeX - offsetX , sizeY - offsetY , uBottomRight , vTopLeft} ,
					{sizeX - offsetX , -offsetY , uBottomRight , vBottomRight} ,
					{-offsetX , -offsetY , uTopLeft , vBottomRight}})
	end
	
-- Get quad size
	function utility.getQuadSize(mesh)
		local xOne , yOne = mesh:getVertex(1)
		local xTwo , yTwo = mesh:getVertex(3)
		
		return math.abs(xTwo - xOne) , math.abs(yTwo - yOne)
	end
