---- Main
-- Load
	function love.load()
		bit = require("bit")
			
		require "generic.vector"
		require "generic.matrix"
		require "generic.math"
		require "generic.utility"
		--require "generic.quickSort"
		require "generic.radixSort"
		require "assetManager"
		require "systemManager"
		require "world"
		require "colors"
		
	-- Globals
		deltaTime = 0
		timeElapsed = 0
		positionMouse = vector:new()
		vectorMouse = vector:new()
		
	-- Graphics settings
		love.graphics.setBackgroundColor(color.grey)
	
		--love.graphics.setDefaultFilter("nearest" , "nearest" , 0)
		
		love.graphics.setPointStyle("rough")
		love.graphics.setPointSize(8)
		
		love.graphics.setLineWidth(0.015)
		love.graphics.setLineStyle("rough")
		
	-- Load assets
		assetManager.load()
		
	-- Load systems
		systemManager.load()
	
	-- New world
		world.new()
	
	-- Add scene
		world.loadScene("test")
		
	--Initiate systems
		systemManager.init()
		
	-- GUI stuff
		love.mouse.setVisible(false)
		guiCrossHair = create.entityGUI("guiCrossHair")

		isDebug = false
	end
	
-- Key Pressed
	function love.keypressed(key)
	-- Toggle debug mode
		if key == "<" then
			isDebug = not isDebug
		end
	
	-- Quit
		if key == "escape" then
			love.event.quit()
		end
	end
	
-- Update
	function love.update(dt)
		deltaTime = dt
		timeElapsed = timeElapsed + deltaTime
		
		positionMouse.x = ((love.mouse.getX() + 0.1) / love.graphics:getWidth()) * 2 - 1
		positionMouse.y = -(((love.mouse.getY() + 0.1) / love.graphics:getHeight()) * 2 - 1)
		
		vectorMouse.x = positionMouse.x
		vectorMouse.y = positionMouse.y
		vectorMouse:normalize()
		
		guiCrossHair:setPosition(positionMouse.x , positionMouse.y * world.camera.aspect.y)
		
		world.update()
	end

-- Draw
	function love.draw()
		world.draw()
	end
