-- System base class
	system = {}
	system.__index = system

----Initiate
	function system:init()
	end

---- First
	function system:first()
	end

---- Process
	function system:process()
	end
	
---- Last
	function system:last()
	end

---- Debug callbacks
-- First
	function system:firstDebug()
	end

-- Process
	function system:processDebug()
	end
	
-- Last
	function system:lastDebug()
	end
	
---- Functions
-- Iterate entities and process
	function system:iterate(entityObject)
		if bit.band(entityObject.key , self.lock) == self.lock then
			self:process(entityObject)
		end
		
		for _ , child in pairs(entityObject.children) do
			self:iterate(child)
		end
	end
	
-- Iterate and debug
	function system:iterateDebug(entityObject)
		if bit.band(entityObject.key , self.lock) == self.lock then
			love.graphics.getShader():send("matrix" , entityObject.transform.matrixToShader)
			self:processDebug(entityObject)
		end
		
		for _ , child in pairs(entityObject.children) do
			self:iterateDebug(child)
		end
	end
	
----Constructor
	function system:new()
		local object = {}
		
		setmetatable(object , self)
		
		return object
	end
